package io.tswf.minecraft.blockventure.core.transmutation

import com.mojang.datafixers.types.Type as MojangDatafixerType
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtExit
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ClassReference
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.MethodDescription
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Self
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Transmute
import io.tswf.groovy.bettergroovy.asm.transmutation.meta.MissingTargetStrategy
import io.tswf.minecraft.blockventure.core.view.ViewBlockEntityType
import net.minecraft.block.entity.BlockEntityType

@CompileStatic
class TransmutationBlockEntityType {

    @Transmute(
            targetClass = @ClassReference(BlockEntityType),
            targetMethod = @MethodDescription(
                    name = "<init>",
                    parameterTypeClasses = [ BlockEntityType.BlockEntityFactory, Set, MojangDatafixerType ],
                    returnType = @ClassReference(descriptor = "V")
            ),
            onMissing = MissingTargetStrategy.THROW
    )
    @AtExit
    static void makeBlocksListMutable(BlockEntityType.BlockEntityFactory blockEntityFactory, Set setOfBlocks, MojangDatafixerType datafixerType, @Self BlockEntityType self) {
        def blockEntityTypeView = (ViewBlockEntityType) self
        blockEntityTypeView.blocks = new HashSet<>(blockEntityTypeView.blocks)
    }
}
